Index: issm/trunk/src/c/modules/ConstraintsStatex/ThermalIsPresent.cpp
===================================================================
--- issm/trunk/src/c/modules/ConstraintsStatex/ThermalIsPresent.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/ConstraintsStatex/ThermalIsPresent.cpp	(revision 13975)
@@ -27,8 +27,8 @@
 		}
 	}
-	
+
 	#ifdef _HAVE_MPI_
-	MPI_Reduce (&found,&mpi_found,1,MPI_INT,MPI_SUM,0,MPI_COMM_WORLD );
-	MPI_Bcast(&mpi_found,1,MPI_INT,0,MPI_COMM_WORLD);                
+	MPI_Reduce (&found,&mpi_found,1,MPI_INT,MPI_SUM,0,IssmComm::GetComm() );
+	MPI_Bcast(&mpi_found,1,MPI_INT,0,IssmComm::GetComm());                
 	found=mpi_found;
 	#endif
Index: issm/trunk/src/c/modules/ContourToMeshx/ContourToMeshx.cpp
===================================================================
--- issm/trunk/src/c/modules/ContourToMeshx/ContourToMeshx.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/ContourToMeshx/ContourToMeshx.cpp	(revision 13975)
@@ -8,12 +8,7 @@
 #endif
 
-
 #include "./ContourToMeshx.h"
 
 int ContourToMeshx(SeqVec<double>** pin_nod,SeqVec<double>** pin_elem, double* index, double* x, double* y,DataSet* contours,char* interptype,int nel,int nods, int edgevalue) {
-
-	int noerr=1;
-	int i;
-	int m,n;
 
 	/*Contour:*/
@@ -27,5 +22,4 @@
 	num=_NUMTHREADS_;
 	#endif
-
 
 	/*output: */
@@ -54,5 +48,5 @@
 	/*Take care of the case where an element interpolation has been requested: */
 	if ((strcmp(interptype,"element")==0) || (strcmp(interptype,"element and node")==0)){
-		for (n=0;n<nel;n++){
+		for(int n=0;n<nel;n++){
 			if ( (in_nod_serial[ (int)*(index+3*n+0) -1] == 1) && (in_nod_serial[ (int)*(index+3*n+1) -1] == 1) && (in_nod_serial[ (int)*(index+3*n+2) -1] == 1) ){
 				value=1; in_elem->SetValue(n,value,INS_VAL);
@@ -71,4 +65,4 @@
 	xDelete<double>(in_nod_serial);
 
-	return noerr;
+	return 1;
 }
Index: issm/trunk/src/c/modules/ContourToNodesx/ContourToNodesx.cpp
===================================================================
--- issm/trunk/src/c/modules/ContourToNodesx/ContourToNodesx.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/ContourToNodesx/ContourToNodesx.cpp	(revision 13975)
@@ -7,5 +7,4 @@
 
 	int i;
-	int m,n;
 
 	/*Contour:*/
@@ -14,5 +13,4 @@
 	double*  xc=NULL;
 	double*  yc=NULL;
-	double   value;
 
 	/*output: */
@@ -34,5 +32,4 @@
 	/*Assign output pointers: */
 	*pflags=flags;
-	
 	return 1;
 }
@@ -40,13 +37,8 @@
 int ContourToNodesx(SeqVec<IssmPDouble>** pflags,double* x, double* y, int nods, DataSet* contours, int edgevalue){
 
-	int i;
-	int m,n;
-
 	/*Contour:*/
 	Contour<IssmPDouble>* contouri=NULL;
-	int      numnodes;
 	double*  xc=NULL;
 	double*  yc=NULL;
-	double   value;
 
 	/*output: */
@@ -56,5 +48,5 @@
 	/*Loop through all contours: */
 	if(contours){
-		for (i=0;i<contours->Size();i++){
+		for(int i=0;i<contours->Size();i++){
 			Contour<IssmPDouble>* contour=(Contour<IssmPDouble>*)contours->GetObjectByOffset(i);
 			IsInPoly(flags,contour->x,contour->y,contour->nods,x,y,0,nods,edgevalue);
Index: issm/trunk/src/c/modules/CreateNodalConstraintsx/CreateNodalConstraintsx.cpp
===================================================================
--- issm/trunk/src/c/modules/CreateNodalConstraintsx/CreateNodalConstraintsx.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/CreateNodalConstraintsx/CreateNodalConstraintsx.cpp	(revision 13975)
@@ -12,8 +12,5 @@
 void CreateNodalConstraintsx( Vector<IssmDouble>** pys, Nodes* nodes,int configuration_type){
 
-	int i;
-	
-	/*intermediary: */
-	int  numberofdofs;
+	bool  oldalloc  = false;
 
 	/*output: */
@@ -21,12 +18,16 @@
 
 	/*figure out how many dofs we have: */
-	numberofdofs=nodes->NumberOfDofs(configuration_type,SsetEnum);
+	int ssize=nodes->NumberOfDofs(configuration_type,SsetEnum);
+	int slocalsize = nodes->NumberOfDofsLocal(configuration_type,SsetEnum);
 
 	/*allocate:*/
-	ys=new Vector<IssmDouble>(numberofdofs);
+	if(oldalloc)
+	 ys=new Vector<IssmDouble>(ssize);
+	else
+	 ys=new Vector<IssmDouble>(slocalsize,ssize);
 
 	/*go through all nodes, and for the ones corresponding to this configuration_type, fill the 
 	 * constraints vector with the constraint values: */
-	for (i=0;i<nodes->Size();i++){
+	for(int i=0;i<nodes->Size();i++){
 		Node* node=(Node*)nodes->GetObjectByOffset(i);
 		if (node->InAnalysis(configuration_type)){
Index: issm/trunk/src/c/modules/Delta18oParameterizationx/Delta18oParameterizationx.cpp
===================================================================
--- issm/trunk/src/c/modules/Delta18oParameterizationx/Delta18oParameterizationx.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/Delta18oParameterizationx/Delta18oParameterizationx.cpp	(revision 13975)
@@ -15,8 +15,8 @@
   int    i;
   Element* element = NULL;
- 
+
   /*Compute temperature and precipitation fields: */
   for(i=0;i<elements->Size();i++){
-    element=(Element*)elements->GetObjectByOffset(i);
+    element=dynamic_cast<Element*>(elements->GetObjectByOffset(i));
     element->Delta18oParameterization();
   }  
Index: issm/trunk/src/c/modules/DragCoefficientAbsGradientx/DragCoefficientAbsGradientx.cpp
===================================================================
--- issm/trunk/src/c/modules/DragCoefficientAbsGradientx/DragCoefficientAbsGradientx.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/DragCoefficientAbsGradientx/DragCoefficientAbsGradientx.cpp	(revision 13975)
@@ -22,5 +22,5 @@
 	/*Compute Misfit: */
 	for (i=0;i<elements->Size();i++){
-		element=(Element*)elements->GetObjectByOffset(i);
+		element=dynamic_cast<Element*>(elements->GetObjectByOffset(i));
 		J+=element->DragCoefficientAbsGradient(process_units,weight_index);
 	}
@@ -28,6 +28,6 @@
 	/*Sum all J from all cpus of the cluster:*/
 	#ifdef _HAVE_MPI_
-	MPI_Reduce (&J,&J_sum,1,MPI_DOUBLE,MPI_SUM,0,MPI_COMM_WORLD );
-	MPI_Bcast(&J_sum,1,MPI_DOUBLE,0,MPI_COMM_WORLD);
+	MPI_Reduce (&J,&J_sum,1,MPI_DOUBLE,MPI_SUM,0,IssmComm::GetComm() );
+	MPI_Bcast(&J_sum,1,MPI_DOUBLE,0,IssmComm::GetComm());
 	J=J_sum;
 	#endif
Index: issm/trunk/src/c/modules/EnumToStringx/EnumToStringx.cpp
===================================================================
--- issm/trunk/src/c/modules/EnumToStringx/EnumToStringx.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/EnumToStringx/EnumToStringx.cpp	(revision 13975)
@@ -18,11 +18,23 @@
 
 		case AutodiffIsautodiffEnum : return "AutodiffIsautodiff";
-		case AutodiffDependentsEnum : return "AutodiffDependents";
 		case AutodiffNumDependentsEnum : return "AutodiffNumDependents";
-		case AutodiffIndependentsEnum : return "AutodiffIndependents";
+		case AutodiffNumDependentObjectsEnum : return "AutodiffNumDependentObjects";
+		case AutodiffDependentObjectNamesEnum : return "AutodiffDependentObjectNames";
+		case AutodiffDependentObjectTypesEnum : return "AutodiffDependentObjectTypes";
+		case AutodiffDependentObjectIndicesEnum : return "AutodiffDependentObjectIndices";
+		case AutodiffDependentObjectsEnum : return "AutodiffDependentObjects";
 		case AutodiffNumIndependentsEnum : return "AutodiffNumIndependents";
+		case AutodiffNumIndependentObjectsEnum : return "AutodiffNumIndependentObjects";
+		case AutodiffIndependentObjectNamesEnum : return "AutodiffIndependentObjectNames";
+		case AutodiffIndependentObjectTypesEnum : return "AutodiffIndependentObjectTypes";
+		case AutodiffIndependentObjectsEnum : return "AutodiffIndependentObjects";
 		case AutodiffJacobianEnum : return "AutodiffJacobian";
 		case AutodiffXpEnum : return "AutodiffXp";
-		case AutodiffFosForwardOutputEnum : return "AutodiffFosForwardOutput";
+		case AutodiffDriverEnum : return "AutodiffDriver";
+		case AutodiffFosForwardIndexEnum : return "AutodiffFosForwardIndex";
+		case AutodiffFovForwardIndicesEnum : return "AutodiffFovForwardIndices";
+		case AutodiffFosReverseIndexEnum : return "AutodiffFosReverseIndex";
+		case AutodiffMassFluxSegmentsPresentEnum : return "AutodiffMassFluxSegmentsPresent";
+		case AutodiffKeepEnum : return "AutodiffKeep";
 		case BalancethicknessSpcthicknessEnum : return "BalancethicknessSpcthickness";
 		case BalancethicknessStabilizationEnum : return "BalancethicknessStabilization";
@@ -36,4 +48,5 @@
 		case ConstantsReferencetemperatureEnum : return "ConstantsReferencetemperature";
 		case ConstantsYtsEnum : return "ConstantsYts";
+		case DependentObjectEnum : return "DependentObject";
 		case DiagnosticAbstolEnum : return "DiagnosticAbstol";
 		case DiagnosticIcefrontEnum : return "DiagnosticIcefront";
@@ -75,4 +88,5 @@
 		case HydrologySpcwatercolumnEnum : return "HydrologySpcwatercolumn";
 		case HydrologyStabilizationEnum : return "HydrologyStabilization";
+		case IndependentObjectEnum : return "IndependentObject";
 		case InversionControlParametersEnum : return "InversionControlParameters";
 		case InversionCostFunctionEnum : return "InversionCostFunction";
@@ -148,6 +162,10 @@
 		case PrognosticStabilizationEnum : return "PrognosticStabilization";
 		case PrognosticVertexPairingEnum : return "PrognosticVertexPairing";
+		case PrognosticNumRequestedOutputsEnum : return "PrognosticNumRequestedOutputs";
+		case PrognosticRequestedOutputsEnum : return "PrognosticRequestedOutputs";
 		case QmuIsdakotaEnum : return "QmuIsdakota";
-		case QmuMassFluxSegmentsEnum : return "QmuMassFluxSegments";
+		case MassFluxSegmentsEnum : return "MassFluxSegments";
+		case MassFluxSegmentsPresentEnum : return "MassFluxSegmentsPresent";
+		case QmuMassFluxSegmentsPresentEnum : return "QmuMassFluxSegmentsPresent";
 		case QmuNumberofpartitionsEnum : return "QmuNumberofpartitions";
 		case QmuNumberofresponsesEnum : return "QmuNumberofresponses";
@@ -184,4 +202,6 @@
 		case SurfaceforcingsMonthlytemperaturesEnum : return "SurfaceforcingsMonthlytemperatures";
 		case SurfaceforcingsHcEnum : return "SurfaceforcingsHc";
+		case SurfaceforcingsHrefEnum : return "SurfaceforcingsHref";
+		case SurfaceforcingsSmbrefEnum : return "SurfaceforcingsSmbref";
 		case SurfaceforcingsSmbPosMaxEnum : return "SurfaceforcingsSmbPosMax";
 		case SurfaceforcingsSmbPosMinEnum : return "SurfaceforcingsSmbPosMin";
@@ -270,4 +290,5 @@
 		case DofIndexingEnum : return "DofIndexing";
 		case DoubleInputEnum : return "DoubleInput";
+		case DataSetParamEnum : return "DataSetParam";
 		case DoubleMatArrayParamEnum : return "DoubleMatArrayParam";
 		case DoubleMatParamEnum : return "DoubleMatParam";
@@ -299,4 +320,5 @@
 		case PentaEnum : return "Penta";
 		case PentaP1InputEnum : return "PentaP1Input";
+		case ProfilerEnum : return "Profiler";
 		case MatrixParamEnum : return "MatrixParam";
 		case VectorParamEnum : return "VectorParam";
@@ -467,4 +489,6 @@
 		case OldGradientEnum : return "OldGradient";
 		case OutputFilePointerEnum : return "OutputFilePointer";
+		case OutputFileNameEnum : return "OutputFileName";
+		case LockFileNameEnum : return "LockFileName";
 		case PetscOptionsAnalysesEnum : return "PetscOptionsAnalyses";
 		case PetscOptionsStringsEnum : return "PetscOptionsStrings";
Index: issm/trunk/src/c/modules/GetSolutionFromInputsx/GetSolutionFromInputsx.cpp
===================================================================
--- issm/trunk/src/c/modules/GetSolutionFromInputsx/GetSolutionFromInputsx.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/GetSolutionFromInputsx/GetSolutionFromInputsx.cpp	(revision 13975)
@@ -27,11 +27,11 @@
 	gsize=nodes->NumberOfDofs(configuration_type,GsetEnum);
 	if (gsize==0) _error_("Allocating a Vec of size 0 as gsize=0 for configuration: " << EnumToStringx(configuration_type));
-	
+
 	/*Initialize solution: */
 	solution=new Vector<IssmDouble>(gsize);
-	
+
 	/*Go through elements and plug solution: */
 	for (i=0;i<elements->Size();i++){
-		element=(Element*)elements->GetObjectByOffset(i);
+		element=dynamic_cast<Element*>(elements->GetObjectByOffset(i));
 		element->GetSolutionFromInputs(solution);
 	}
Index: issm/trunk/src/c/modules/GetVectorFromInputsx/GetVectorFromInputsx.cpp
===================================================================
--- issm/trunk/src/c/modules/GetVectorFromInputsx/GetVectorFromInputsx.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/GetVectorFromInputsx/GetVectorFromInputsx.cpp	(revision 13975)
@@ -21,5 +21,5 @@
 		/*Look up in elements*/
 		for(i=0;i<elements->Size();i++){
-			Element* element=(Element*)elements->GetObjectByOffset(i);
+			Element* element=dynamic_cast<Element*>(elements->GetObjectByOffset(i));
 			element->GetVectorFromInputs(vector,name);
 		}
@@ -42,8 +42,8 @@
 
 void GetVectorFromInputsx( IssmDouble** pvector, Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters, int name, int type){
-	
+
 	/*output: */
 	IssmDouble* vector=NULL;
-	
+
 	/*intermediary: */
 	Vector<IssmDouble>* vec_vector=NULL;
Index: issm/trunk/src/c/modules/GroundinglineMigrationx/GroundinglineMigrationx.cpp
===================================================================
--- issm/trunk/src/c/modules/GroundinglineMigrationx/GroundinglineMigrationx.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/GroundinglineMigrationx/GroundinglineMigrationx.cpp	(revision 13975)
@@ -19,7 +19,7 @@
 	Vector<IssmDouble>*      vec_old_floatingice              = NULL;
 	Element* element                          = NULL;
-	
+
 	if(VerboseModule()) _pprintLine_("   Migrating grounding line");
-	
+
 	/*retrieve parameters: */
 	parameters->FindParam(&migration_style,GroundinglineMigrationEnum);
@@ -43,5 +43,5 @@
 	/*Migrate grounding line : */
 	for(i=0;i<elements->Size();i++){
-		element=(Element*)elements->GetObjectByOffset(i);
+		element=dynamic_cast<Element*>(elements->GetObjectByOffset(i));
 		element->MigrateGroundingLine(old_floatingice,vertices_ungrounding);
 	}
@@ -95,5 +95,5 @@
 	/*Fill vector vertices_potentially_floating: */
 	for(i=0;i<elements->Size();i++){
-		element=(Element*)elements->GetObjectByOffset(i);
+		element=dynamic_cast<Element*>(elements->GetObjectByOffset(i));
 		element->PotentialSheetUngrounding(vec_vertices_potentially_ungrounding);
 	}
@@ -121,5 +121,4 @@
 	Element* element                               = NULL;
 
-
 	/*recover parameters: */
 	parameters->FindParam(&analysis_type,AnalysisTypeEnum);
@@ -132,5 +131,5 @@
 	nflipped=1; //bootstrap
 	while(nflipped){
-		
+
 		/*Vector of size number of elements*/
 		vec_elements_neighboring_floatingice=new Vector<IssmDouble>(elements->NumberOfElements(),true);
@@ -138,5 +137,5 @@
 		/*Figure out if any of the nodes of the element will be floating -> elements neighbouting the floating ice*/
 		for(i=0;i<elements->Size();i++){
-			element=(Element*)elements->GetObjectByOffset(i);
+			element=dynamic_cast<Element*>(elements->GetObjectByOffset(i));
 			vec_elements_neighboring_floatingice->SetValue(element->Sid(),element->IsNodeOnShelfFromFlags(nodes_on_floatingice)?1.0:0.0,INS_VAL);
 		}
@@ -149,5 +148,5 @@
 		local_nflipped=0;
 		for(i=0;i<elements->Size();i++){
-			element=(Element*)elements->GetObjectByOffset(i);
+			element=dynamic_cast<Element*>(elements->GetObjectByOffset(i));
 			if(reCast<int,IssmDouble>(elements_neighboring_floatingce[element->Sid()])){
 				local_nflipped+=element->UpdatePotentialSheetUngrounding(vertices_potentially_ungrounding,vec_nodes_on_floatingice,nodes_on_floatingice);
@@ -155,7 +154,7 @@
 		}
 		vec_nodes_on_floatingice->Assemble();
-		
+
 		#ifdef _HAVE_MPI_
-		MPI_Allreduce(&local_nflipped,&nflipped,1,MPI_INT,MPI_SUM,MPI_COMM_WORLD);
+		MPI_Allreduce(&local_nflipped,&nflipped,1,MPI_INT,MPI_SUM,IssmComm::GetComm());
 		if(VerboseConvergence()) _pprintLine_("   Additional number of vertices allowed to unground: " << nflipped);
 		#else
Index: issm/trunk/src/c/modules/HoleFillerx/HoleFillerx.cpp
===================================================================
--- issm/trunk/src/c/modules/HoleFillerx/HoleFillerx.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/HoleFillerx/HoleFillerx.cpp	(revision 13975)
@@ -10,14 +10,10 @@
 
 int HoleFillerx(double** pimageout,double* image, int lines,int samps,int smooth){
-	
-	FILE 			*fp1;
-	unsigned long	filesize;
+
 	long			infinit;
 	double          temp;
-	long			i, j, k, l, ii, jj, bytes;
+	long			i, j, k, l, ii, jj;
 	long			iii, jjj;
-	long			test, prevlines, prevpix, test1, test2, thresh,counter;
-	long			bell, cycles, leftovers;
-	float			howlong;
+	long			test;
 	float			nsteps, ssteps, wsteps, esteps;
 	float			nwsteps, nesteps, swsteps, sesteps;
@@ -29,5 +25,5 @@
 	float			ssw, wsw, wnw, nnw;	
 	float			sum;
-	
+
 	time_t			t1, t2;
 
@@ -39,11 +35,8 @@
 	double*         image4=NULL;
 
-	/*Added to original routine: */
-	int             imageoutsize;
-
 	 /*^^^^^^^^^^^^^  Remove pixels close to the holes ^^^^^^^^^^^^^*/
 	image2 = xNew<double>(lines*samps);
 	memcpy(image2,image,lines*samps*sizeof(double));
-	
+
   	for ( i = 0; i < lines; i++ ){
   		for ( j = 0; j < samps; j++ ){
@@ -84,5 +77,5 @@
 
 	again2:	
-	
+
 	#ifdef _DEBUG2_
 		counter=0;
@@ -99,5 +92,5 @@
 		fflush( stdout );
 	#endif
-	
+
 	afterfirst2:
 
@@ -128,5 +121,5 @@
 
 			/* For void edge pixels: */			
-			
+
 			nsteps = 0.0; ssteps = 0.0; esteps = 0.0; wsteps = 0.0;
 			nwsteps = 0.0; nesteps = 0.0; swsteps = 0.0; sesteps = 0.0;
@@ -139,5 +132,4 @@
 			ssw = 0.0; wsw = 0.0; wnw = 0.0; nnw = 0.0;
 
-
 /** NSEW **/
 			for ( ii = i - 1; ii >= 0; ii-- ){   /* North */
@@ -150,10 +142,10 @@
 				if ( *(image2+ii*samps+j) != 0 ){ south = *(image2+ii*samps+j); ssteps = ii - i; break;}
 			}
-				
+
 			for ( jj = j - 1; jj >= 0; jj-- ){   /* West */
 				if ( jj <= 0 ) { west = 0; wsteps = 0; break;}
 				if ( *(image2+i*samps+jj) != 0 ){ west = *(image2+i*samps+jj); wsteps = j - jj; break;}
 			}
-				
+
 			for ( jj = j + 1; jj < samps; jj++ ){ /* East */
 				if ( jj >= samps-1 ){ east = 0; esteps = 0; break;}
@@ -161,5 +153,4 @@
 			}
 
-				
 /** Diagonals  **/						
 			/* Southeast */
@@ -169,5 +160,5 @@
 				if ( *(image2+ii*samps+jj) != 0 ){ se = *(image2+ii*samps+jj); sesteps = 1.4142 * k; break;}
 			}
-			
+
 			/* Northeast */
 			for ( k = 1; k < infinit; k++ ){
@@ -176,5 +167,5 @@
 				if ( *(image2+ii*samps+jj) != 0 ){ ne = *(image2+ii*samps+jj); nesteps = 1.4142 * k; break;}
 			}
-			
+
 			/* Northwest */
 			for ( k = 1; k < infinit; k++ ){
@@ -183,5 +174,5 @@
 				if ( *(image2+ii*samps+jj) != 0 ){ nw = *(image2+ii*samps+jj); nwsteps = 1.4142 * k; break;}
 			}
-			
+
 			/* Southwest */
 			for ( k = 1; k < infinit; k++ ){
@@ -198,5 +189,5 @@
 				if ( *(image2+ii*samps+jj) != 0 ){ nne = *(image2+ii*samps+jj); nnesteps = 2.2361 * k; break;}
 			}
-			
+
 			/* ENE */
 			for ( k = 1; k < infinit; k++ ){
@@ -205,5 +196,5 @@
 				if ( *(image2+ii*samps+jj) != 0 ){ ene = *(image2+ii*samps+jj); enesteps = 2.2361 * k; break;}
 			}
-			
+
 			/* ESE */
 			for ( k = 1; k < infinit; k++ ){
@@ -212,5 +203,5 @@
 				if ( *(image2+ii*samps+jj) != 0 ){ ese = *(image2+ii*samps+jj); esesteps = 2.2361 * k; break;}
 			}
-			
+
 			/* SSE */
 			for ( k = 1; k < infinit; k++ ){
@@ -226,5 +217,5 @@
 				if ( *(image2+ii*samps+jj) != 0 ){ ssw = *(image2+ii*samps+jj); sswsteps = 2.2361 * k; break;}
 			}
-			
+
 			/* WSW */
 			for ( k = 1; k < infinit; k++ ){
@@ -233,5 +224,5 @@
 				if ( *(image2+ii*samps+jj) != 0 ){ wsw = *(image2+ii*samps+jj); wswsteps = 2.2361 * k; break;}
 			}
-			
+
 			/* WNW */
 			for ( k = 1; k < infinit; k++ ){
@@ -240,5 +231,5 @@
 				if ( *(image2+ii*samps+jj) != 0 ){ wnw = *(image2+ii*samps+jj); wnwsteps = 2.2361 * k; break;}
 			}
-			
+
 			/* NNW */
 			for ( k = 1; k < infinit; k++ ){
@@ -247,5 +238,5 @@
 				if ( *(image2+ii*samps+jj) != 0 ){ nnw = *(image2+ii*samps+jj); nnwsteps = 2.2361 * k; break;}
 			}
-			
+
 			elev = 0; range = 0;
 /*NSEW*/			
@@ -259,5 +250,5 @@
 			if ( swsteps > 0.5 ){ elev +=    sw / swsteps; range +=  1.00 / swsteps;}
 			if ( sesteps > 0.5 ){ elev +=    se / sesteps; range +=  1.00 / sesteps;}
-			
+
 /*Other 8*/
 			if ( nnesteps > 0.5 ){ elev += nne / nnesteps; range +=  1.00 / nnesteps;}
@@ -269,5 +260,5 @@
 			if ( wnwsteps > 0.5 ){ elev += wnw / wnwsteps; range +=  1.00 / wnwsteps;}
 			if ( nnwsteps > 0.5 ){ elev += nnw / nnwsteps; range +=  1.00 / nnwsteps;}
-									
+
 			//temp = ( elev / range ) + 0.5 ;
 			temp = ( elev / range );
@@ -275,5 +266,5 @@
 			//if ( temp > 10000 ) temp = 10000;
 			//if ( temp <     0 ) temp =     0;
-			
+
 			#ifdef _DEBUG2_
 				//_printLine_(temp << " " << elev << " " << range << " ");
@@ -284,6 +275,4 @@
 	}
 
-
-
 	for ( i = 0; i < lines; i++ ){
 		for ( j = 0; j < samps; j++ ){
@@ -292,5 +281,4 @@
 	}
 
-
 	for ( i = 0; i < lines; i++ ){
 		for ( j = 0; j < samps; j++ ){
@@ -298,18 +286,15 @@
 		}
 	}
-	
+
 	if ( smooth == 0 ) goto there2;		
-		
-		
+
 /************************ SMOOTH THE RESULT ***********************/		
-		
+
 	image4 = xNew<double>(lines*samps);
 	memcpy(image4,image3,lines*samps*sizeof(double));
-
 
 	for ( i = 0; i < lines; i++ ) {
 		for ( j = 0; j < samps; j++ ) {
 			if ( *(image4+i*samps+j) != 0 ) { *(image3+i*samps+j) = *(image2+i*samps+j) ; continue; }
-
 
 			for ( k = 1; k < infinit; k++ ) { /* Find the smallest box size with data */ 
@@ -324,5 +309,5 @@
 				}
 			}
-		
+
 			k_nowset:
 			k = k / 4; if ( k < 1 ) k = 1; /* Errrrr.  Make it fourth size */
@@ -343,7 +328,5 @@
 	}
 
-		
 there2:		
-
 
 	/*Allocate output image: */
@@ -352,5 +335,5 @@
 
 	time(&t2);	
-	
+
 	#ifdef _DEBUG2_
 		_printString_( "\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b" );
@@ -358,5 +341,5 @@
 		printf ( "\n");
 	#endif
-	
+
 	end:
 
Index: issm/trunk/src/c/modules/InputArtificialNoisex/InputArtificialNoisex.cpp
===================================================================
--- issm/trunk/src/c/modules/InputArtificialNoisex/InputArtificialNoisex.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/InputArtificialNoisex/InputArtificialNoisex.cpp	(revision 13975)
@@ -15,5 +15,5 @@
 	/*Update elements, nodes, loads and materials from inputs: */
 	for(i=0;i<elements->Size();i++){
-		Element* element=(Element*)elements->GetObjectByOffset(i);
+		Element* element=dynamic_cast<Element*>(elements->GetObjectByOffset(i));
 		element->InputArtificialNoise(enum_name,min,max);
 	}
Index: issm/trunk/src/c/modules/InputControlUpdatex/InputControlUpdatex.cpp
===================================================================
--- issm/trunk/src/c/modules/InputControlUpdatex/InputControlUpdatex.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/InputControlUpdatex/InputControlUpdatex.cpp	(revision 13975)
@@ -13,5 +13,5 @@
 	/*Go through elemnets, and ask to carry out the operation on inputs: */
 	for(int i=0;i<elements->Size();i++){
-		Element* element=(Element*)elements->GetObjectByOffset(i);
+		Element* element=dynamic_cast<Element*>(elements->GetObjectByOffset(i));
 		element->InputControlUpdate(scalar,save_parameter);
 	}
Index: issm/trunk/src/c/modules/InputConvergencex/InputConvergencex.cpp
===================================================================
--- issm/trunk/src/c/modules/InputConvergencex/InputConvergencex.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/InputConvergencex/InputConvergencex.cpp	(revision 13975)
@@ -24,5 +24,5 @@
 	/*Go through elements, and ask them to do the job: */
 	for(i=0;i<elements->Size();i++){
-		element=(Element*)elements->GetObjectByOffset(i);
+		element=dynamic_cast<Element*>(elements->GetObjectByOffset(i));
 		converged=element->InputConvergence(eps,enums,num_enums,criterionenums,criterionvalues,num_criterionenums);
 		if(!converged) num_notconverged++;
@@ -31,5 +31,5 @@
 	/*In parallel, we need to gather the converged status: */
 	#ifdef _HAVE_MPI_
-	MPI_Allreduce ( (void*)&num_notconverged,(void*)&total_notconverged,1,MPI_INT,MPI_SUM,MPI_COMM_WORLD);
+	MPI_Allreduce ( (void*)&num_notconverged,(void*)&total_notconverged,1,MPI_INT,MPI_SUM,IssmComm::GetComm());
 	num_notconverged=total_notconverged;
 	#endif
Index: issm/trunk/src/c/modules/InputDuplicatex/InputDuplicatex.cpp
===================================================================
--- issm/trunk/src/c/modules/InputDuplicatex/InputDuplicatex.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/InputDuplicatex/InputDuplicatex.cpp	(revision 13975)
@@ -10,9 +10,9 @@
 
 void InputDuplicatex(Elements* elements,Nodes* nodes,Vertices* vertices,Loads* loads,Materials* materials,Parameters* parameters,int original_enum, int new_enum){
-	
+
 	/*Go through elemnets, and ask to reinitialie the input: */
 	int      i;
 	for(i=0;i<elements->Size();i++){
-		Element* element=(Element*)elements->GetObjectByOffset(i);
+		Element* element=dynamic_cast<Element*>(elements->GetObjectByOffset(i));
 		element->InputDuplicate(original_enum,new_enum);
 	}
Index: issm/trunk/src/c/modules/InputScalex/InputScalex.cpp
===================================================================
--- issm/trunk/src/c/modules/InputScalex/InputScalex.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/InputScalex/InputScalex.cpp	(revision 13975)
@@ -16,5 +16,5 @@
 	/*Go through elemnets, and ask to reinitialie the input: */
 	for(i=0;i<elements->Size();i++){
-		Element* element=(Element*)elements->GetObjectByOffset(i);
+		Element* element=dynamic_cast<Element*>(elements->GetObjectByOffset(i));
 		element->InputScale(enum_type,scale_factor);
 	}
Index: issm/trunk/src/c/modules/InputToResultx/InputToResultx.cpp
===================================================================
--- issm/trunk/src/c/modules/InputToResultx/InputToResultx.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/InputToResultx/InputToResultx.cpp	(revision 13975)
@@ -23,5 +23,5 @@
 	for(int i=0;i<elements->Size();i++){
 
-		element=(Element*)elements->GetObjectByOffset(i);
+		element=dynamic_cast<Element*>(elements->GetObjectByOffset(i));
 		element->InputToResult(enum_type,step,time);
 	}
Index: issm/trunk/src/c/modules/InputUpdateFromConstantx/InputUpdateFromConstantx.cpp
===================================================================
--- issm/trunk/src/c/modules/InputUpdateFromConstantx/InputUpdateFromConstantx.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/InputUpdateFromConstantx/InputUpdateFromConstantx.cpp	(revision 13975)
@@ -15,5 +15,5 @@
 	/*Elements and loads drive the update: */
 	for(i=0;i<elements->Size();i++){
-		Element* element=(Element*)elements->GetObjectByOffset(i);
+		Element* element=dynamic_cast<Element*>(elements->GetObjectByOffset(i));
 		element->InputUpdateFromConstant(constant,name);
 	}
@@ -23,5 +23,5 @@
 		load->InputUpdateFromConstant(constant,name);
 	}
-	
+
 	for(i=0;i<materials->Size();i++){
 		Material* material=(Material*)materials->GetObjectByOffset(i);
@@ -30,10 +30,10 @@
 }
 void InputUpdateFromConstantx( Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters,int    constant, int name){
-	
+
 	int i;
 
 	/*Elements and loads drive the update: */
 	for(i=0;i<elements->Size();i++){
-		Element* element=(Element*)elements->GetObjectByOffset(i);
+		Element* element=dynamic_cast<Element*>(elements->GetObjectByOffset(i));
 		element->InputUpdateFromConstant(constant,name);
 	}
@@ -43,5 +43,5 @@
 		load->InputUpdateFromConstant(constant,name);
 	}
-	
+
 	for(i=0;i<materials->Size();i++){
 		Material* material=(Material*)materials->GetObjectByOffset(i);
@@ -55,5 +55,5 @@
 	/*Elements and loads drive the update: */
 	for(i=0;i<elements->Size();i++){
-		Element* element=(Element*)elements->GetObjectByOffset(i);
+		Element* element=dynamic_cast<Element*>(elements->GetObjectByOffset(i));
 		element->InputUpdateFromConstant(constant,name);
 	}
@@ -63,5 +63,5 @@
 		load->InputUpdateFromConstant(constant,name);
 	}
-	
+
 	for(i=0;i<materials->Size();i++){
 		Material* material=(Material*)materials->GetObjectByOffset(i);
Index: issm/trunk/src/c/modules/InputUpdateFromDakotax/InputUpdateFromDakotax.cpp
===================================================================
--- issm/trunk/src/c/modules/InputUpdateFromDakotax/InputUpdateFromDakotax.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/InputUpdateFromDakotax/InputUpdateFromDakotax.cpp	(revision 13975)
@@ -14,5 +14,5 @@
 	int     i,j,k,l;
 	int     dummy;
-	
+
 	int     numberofvertices;
 	int     nrows;
@@ -35,17 +35,16 @@
 
 	for(i=0;i<numvariables;i++){
-	
+
 		descriptor=variables_descriptors[i];
 
 		/*From descriptor, figure out if the variable is scaled, indexed, nodal, or just a simple variable: */
 		if (strncmp(descriptor,"scaled_",7)==0){
-			
+
 			/*Variable is scaled. Determine root name of variable (ex: scaled_DragCoefficient_1 -> DragCoefficient). Allocate distributed_values and fill the 
 			 * distributed_values with the next npart variables: */
-			
+
 			//strcpy(root,strstr(descriptor,"_")+1); *strstr(root,"_")='\0';
 			memcpy(root,strstr(descriptor,"_")+1,(strlen(strstr(descriptor,"_")+1)+1)*sizeof(char));
 			*strstr(root,"_")='\0';
-
 
 			distributed_values=xNew<double>(npart);
@@ -68,19 +67,18 @@
 
 			#ifdef _DEBUG_
-				PetscSynchronizedPrintf(MPI_COMM_WORLD,"Parameter matrix:");
-				PetscSynchronizedFlush(MPI_COMM_WORLD);
+				PetscSynchronizedPrintf(IssmComm::GetComm(),"Parameter matrix:");
+				PetscSynchronizedFlush(IssmComm::GetComm());
 				for(l=0;l<ncols;l++){
-					PetscSynchronizedPrintf(MPI_COMM_WORLD," time %i\n",l);
-					PetscSynchronizedFlush(MPI_COMM_WORLD);
+					PetscSynchronizedPrintf(IssmComm::GetComm()," time %i\n",l);
+					PetscSynchronizedFlush(IssmComm::GetComm());
 
 					for(k=0;k<numberofvertices;k++){
-						PetscSynchronizedPrintf(MPI_COMM_WORLD," node %i value %g\n",k+1,*(parameter+k*ncols+l));
-						PetscSynchronizedFlush(MPI_COMM_WORLD);
+						PetscSynchronizedPrintf(IssmComm::GetComm()," node %i value %g\n",k+1,*(parameter+k*ncols+l));
+						PetscSynchronizedFlush(IssmComm::GetComm());
 					}
 				}
-				PetscSynchronizedPrintf(MPI_COMM_WORLD," descriptor: %s root %s enum: %i\n",descriptor,root,StringToEnumx(root));
-				PetscSynchronizedFlush(MPI_COMM_WORLD);
+				PetscSynchronizedPrintf(IssmComm::GetComm()," descriptor: %s root %s enum: %i\n",descriptor,root,StringToEnumx(root));
+				PetscSynchronizedFlush(IssmComm::GetComm());
 			#endif
-			  
 
 			/*Update inputs using the parameter matrix: */
Index: issm/trunk/src/c/modules/InputUpdateFromMatrixDakotax/InputUpdateFromMatrixDakotax.cpp
===================================================================
--- issm/trunk/src/c/modules/InputUpdateFromMatrixDakotax/InputUpdateFromMatrixDakotax.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/InputUpdateFromMatrixDakotax/InputUpdateFromMatrixDakotax.cpp	(revision 13975)
@@ -22,5 +22,5 @@
 		/*Update elements, nodes, loads and materials from inputs: */
 		for(i=0;i<elements->Size();i++){
-			Element* element=(Element*)elements->GetObjectByOffset(i);
+			Element* element=dynamic_cast<Element*>(elements->GetObjectByOffset(i));
 			element->InputUpdateFromMatrixDakota(matrix,nrows,ncols,name,type);
 		}
Index: issm/trunk/src/c/modules/InputUpdateFromSolutionx/InputUpdateFromSolutionx.cpp
===================================================================
--- issm/trunk/src/c/modules/InputUpdateFromSolutionx/InputUpdateFromSolutionx.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/InputUpdateFromSolutionx/InputUpdateFromSolutionx.cpp	(revision 13975)
@@ -23,5 +23,4 @@
 }
 
-
 void InputUpdateFromSolutionx( Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters,IssmDouble* solution){
 
@@ -32,5 +31,5 @@
 	/*Elements drive the update: */
 	for (i=0;i<elements->Size();i++){
-		element=(Element*)elements->GetObjectByOffset(i);
+		element=dynamic_cast<Element*>(elements->GetObjectByOffset(i));
 		element->InputUpdateFromSolution(solution);
 	}
